#![allow(deprecated)]
use std::fmt;
use std::str;
#[derive(
    Debug,
    Clone,
    PartialEq,
    Eq,
    PartialOrd,
    Ord,
    Hash,
    conjure_object::serde::Deserialize,
    conjure_object::serde::Serialize,
)]
#[serde(crate = "conjure_object::serde")]
pub enum ChunkType {
    #[serde(rename = "ARROW_WITH_RELATIVE_TIMESTAMPS")]
    ArrowWithRelativeTimestamps,
    #[serde(rename = "ARROW_WITH_ABSOLUTE_TIMESTAMPS")]
    ArrowWithAbsoluteTimestamps,
    /// An unknown variant.
    #[serde(untagged)]
    Unknown(Unknown),
}
impl ChunkType {
    /// Returns the string representation of the enum.
    #[inline]
    pub fn as_str(&self) -> &str {
        match self {
            ChunkType::ArrowWithRelativeTimestamps => "ARROW_WITH_RELATIVE_TIMESTAMPS",
            ChunkType::ArrowWithAbsoluteTimestamps => "ARROW_WITH_ABSOLUTE_TIMESTAMPS",
            ChunkType::Unknown(v) => &*v,
        }
    }
}
impl fmt::Display for ChunkType {
    fn fmt(&self, fmt: &mut fmt::Formatter) -> fmt::Result {
        fmt::Display::fmt(self.as_str(), fmt)
    }
}
impl conjure_object::Plain for ChunkType {
    fn fmt(&self, fmt: &mut fmt::Formatter) -> fmt::Result {
        conjure_object::Plain::fmt(self.as_str(), fmt)
    }
}
impl str::FromStr for ChunkType {
    type Err = conjure_object::plain::ParseEnumError;
    #[inline]
    fn from_str(v: &str) -> Result<ChunkType, conjure_object::plain::ParseEnumError> {
        match v {
            "ARROW_WITH_RELATIVE_TIMESTAMPS" => {
                Ok(ChunkType::ArrowWithRelativeTimestamps)
            }
            "ARROW_WITH_ABSOLUTE_TIMESTAMPS" => {
                Ok(ChunkType::ArrowWithAbsoluteTimestamps)
            }
            v => v.parse().map(|v| ChunkType::Unknown(Unknown(v))),
        }
    }
}
impl conjure_object::FromPlain for ChunkType {
    type Err = conjure_object::plain::ParseEnumError;
    #[inline]
    fn from_plain(v: &str) -> Result<ChunkType, conjure_object::plain::ParseEnumError> {
        v.parse()
    }
}
///An unknown variant of the ChunkType enum.
#[derive(
    Debug,
    Clone,
    PartialEq,
    Eq,
    PartialOrd,
    Ord,
    Hash,
    conjure_object::serde::Deserialize,
    conjure_object::serde::Serialize,
)]
#[serde(crate = "conjure_object::serde", transparent)]
pub struct Unknown(conjure_object::private::Variant);
impl std::ops::Deref for Unknown {
    type Target = str;
    #[inline]
    fn deref(&self) -> &str {
        &self.0
    }
}
impl fmt::Display for Unknown {
    #[inline]
    fn fmt(&self, fmt: &mut fmt::Formatter<'_>) -> fmt::Result {
        fmt::Display::fmt(&self.0, fmt)
    }
}
